#include <Carbon/Carbon.r>

#define Reserved8   reserved, reserved, reserved, reserved, reserved, reserved, reserved, reserved
#define Reserved12  Reserved8, reserved, reserved, reserved, reserved
#define Reserved13  Reserved12, reserved
#define dp_none__   noParams, "", directParamOptional, singleItem, notEnumerated, Reserved13
#define reply_none__   noReply, "", replyOptional, singleItem, notEnumerated, Reserved13
#define synonym_verb__ reply_none__, dp_none__, { }
#define plural__    "", {"", kAESpecialClassProperties, cType, "", reserved, singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural}, {}

resource 'aete' (0, "Sound Studio Terminology") {
	0x1,  // major version
	0x0,  // minor version
	english,
	roman,
	{
		"Standard Suite",
		"Common classes and commands for all applications.",
		'core',
		1,
		1,
		{
			/* Events */

			"close",
			"Close a document.",
			'core', 'clos',
			reply_none__,
			'obj ',
			"the document(s) or window(s) to close.",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"saving", 'savo', 'savo',
				"Whether or not changes should be saved before closing.",
				optional,
				singleItem, enumerated, Reserved13,
				"saving in", 'kfil', 'file',
				"the file in which to save the document.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"save",
			"Save a document.",
			'core', 'save',
			reply_none__,
			'obj ',
			"the document(s) or window(s) to save.",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"in", 'kfil', 'file',
				"the complete, absolute file path in which to save the document.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"as", 'fltp', 'TEXT',
				"the file type. Possible values are \"AAC (m4a)\", \"ADTS AAC\", \"Apple Lossless\", \"AIFF Audio\", \"AIFF-C Audio\", \"Core Audio Format\", \"NeXT/Sun Audio\", \"MP3 Audio\", \"Ogg Vorbis\", \"Tab-delimited Text\", \"Wave Audio\".",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"quit",
			"Quit the application.",
			'aevt', 'quit',
			reply_none__,
			dp_none__,
			{
				"saving", 'savo', 'savo',
				"Whether or not changed documents should be saved before closing.",
				optional,
				singleItem, enumerated, Reserved13
			},

			"count",
			"Return the number of elements of a particular class within an object.",
			'core', 'cnte',
			'long',
			"the number of elements",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'obj ',
			"the object whose elements are to be counted",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"each", 'kocl', 'type',
				"the class of objects to be counted.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"delete",
			"Delete an object.",
			'core', 'delo',
			reply_none__,
			'obj ',
			"the object to delete",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"duplicate",
			"Copy object(s) and put the copies at a new location.",
			'core', 'clon',
			reply_none__,
			'obj ',
			"the object(s) to duplicate",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'insh', 'insl',
				"the location for the new object(s).",
				required,
				singleItem, notEnumerated, Reserved13,
				"with properties", 'prdt', 'reco',
				"Properties to be set in the new duplicated object(s).",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"exists",
			"Verify if an object exists.",
			'core', 'doex',
			'bool',
			"true if it exists, false if not",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'****',
			"the object in question",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"make",
			"Make a new object.",
			'core', 'crel',
			'obj ',
			"to the new object",
			replyRequired, singleItem, notEnumerated, Reserved13,
			dp_none__,
			{
				"new", 'kocl', 'type',
				"the class of the new object.",
				required,
				singleItem, notEnumerated, Reserved13,
				"at", 'insh', 'insl',
				"the location at which to insert the object.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"with data", 'data', '****',
				"the initial contents of the object.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"with properties", 'prdt', 'reco',
				"the initial values for properties of the object.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"move",
			"Move object(s) to a new location.",
			'core', 'move',
			reply_none__,
			'obj ',
			"the object(s) to move",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'insh', 'insl',
				"the new location for the object(s).",
				required,
				singleItem, notEnumerated, Reserved13
			}
		},
		{
			/* Classes */

			"application", 'capp',
			"the application's top-level scripting object.",
			{
				"name", 'pnam', 'TEXT',
				"the name of the application.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"frontmost", 'pisf', 'bool',
				"Is this the frontmost (active) application?",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"version", 'vers', 'TEXT',
				"the version of the application.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"playback volume", 'PVol', 'doub',
				"the playback volume in decibels.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"is recording", 'irec', 'bool',
				"Is Sound Studio recording in any document?",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"selection", 'Sel ', 'SSel',
				"the current selection in the frontmost window.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
				'docu', { },
				'cwin', { }
			},
			"applications", 'capp', plural__,

			"document", 'docu',
			"A Sound Studio document.",
			{
				"name", 'pnam', 'TEXT',
				"the document's name.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"modified", 'imod', 'bool',
				"Has the document been modified since the last save?",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"file", 'file', 'file',
				"the document's location on disk.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"sample rate", 'SRte', 'doub',
				"the sample rate in hertz.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"bit rate", 'BRte', 'doub',
				"the bit rate in bits per second.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"sample size", 'SSiz', 'long',
				"the sample size in bits per sample.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"track count", 'NTrk', 'long',
				"the number of tracks (channels).",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"sample count", 'NSmp', 'long',
				"the total number of sample frames.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"total time", 'Time', 'doub',
				"the total duration in seconds.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"loops", 'loop', 'bool',
				"if set to yes, playback repeats.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"options window shown on save", 'Optn', 'bool',
				"if set to yes, show the options window, if any, the next time the file is saved.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"extensionless name", 'NExt', 'TEXT',
				"display name without filename extension.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
				'Mark', { },
				'Trak', { }
			},
			"documents", 'docu', plural__,

			"window", 'cwin',
			"A window.",
			{
				"name", 'pnam', 'TEXT',
				"the full title of the window.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"id", 'ID  ', 'long',
				"the unique identifier of the window.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"index", 'pidx', 'long',
				"the index of the window, ordered front to back.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"bounds", 'pbnd', 'qdrt',
				"the bounding rectangle of the window.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"closeable", 'hclb', 'bool',
				"Whether the window has a close box.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"miniaturizable", 'ismn', 'bool',
				"Whether the window can be minimized.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"miniaturized", 'pmnd', 'bool',
				"Whether the window is currently minimized.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"resizable", 'prsz', 'bool',
				"Whether the window can be resized.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"visible", 'pvis', 'bool',
				"Whether the window is currently visible.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"zoomable", 'iszm', 'bool',
				"Whether the window frame can be zoomed (maximized).",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"zoomed", 'pzum', 'bool',
				"Whether the window frame is currently zoomed (maximized).",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"document", 'docu', 'docu',
				"the document whose contents are being displayed in the window.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"selection", 'Sel ', 'SSel',
				"the current selection in this window.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"horizontal scale", 'HSca', 'doub',
				"the horizontal zoom or scale.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"vertical scale", 'VSca', 'doub',
				"the vertical zoom or scale.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"windows", 'cwin', plural__
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
			'savo',
			{
				"yes", 'yes ', "Save the file.",
				"no", 'no  ', "Do not save the file.",
				"ask", 'ask ', "Ask the user whether or not to save the file."
			}
		},

		"Sound Studio Suite",
		"Sound Studio-specific classes and commands.",
		'SndS',
		1,
		1,
		{
			/* Events */

			"play",
			"Play back audio.",
			'SndS', 'Play',
			reply_none__,
			'obj ',
			"the item(s) to play",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"from", 'from', 'doub',
				"the starting time in seconds.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"to", 'to  ', 'doub',
				"the ending time in seconds.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"record",
			"Record audio at end of file.",
			'SndS', 'Rec ',
			reply_none__,
			'obj ',
			"the document(s) for recording",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"pause",
			"Pause playback or recording.",
			'SndS', 'Paws',
			reply_none__,
			'obj ',
			"the item(s) to pause",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"unpause",
			"Unpause playback or recording.",
			'SndS', 'Unpw',
			reply_none__,
			'obj ',
			"the item(s) to unpause",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"stop",
			"Stop playback or recording.",
			'SndS', 'Stop',
			reply_none__,
			'obj ',
			"the item(s) to stop",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"resample",
			"Resample audio sample data.",
			'SndS', 'Rsmp',
			reply_none__,
			'obj ',
			"the document(s) to resample",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'to  ', 'doub',
				"the new sample rate in hertz.",
				required,
				singleItem, notEnumerated, Reserved13
			},

			"mixdown",
			"Mixdown audio tracks.",
			'SndS', 'Mxdn',
			reply_none__,
			'obj ',
			"the document(s) to mixdown",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'TkCf', 'TkCf',
				"the desired number of tracks to mix down to.",
				required,
				singleItem, enumerated, Reserved13
			},

			"cut",
			"Cut",
			'SndS', 'Cut ',
			reply_none__,
			'obj ',
			"selection",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"copy",
			"Copy",
			'misc', 'copy',
			reply_none__,
			'obj ',
			"selection",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"paste",
			"Paste",
			'SndS', 'Pste',
			reply_none__,
			'obj ',
			"selection",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"existing", 'Exst', 'doub',
				"setting for level for existing, selected audio",
				optional,
				singleItem, notEnumerated, Reserved13,
				"pasteboard", 'PsBd', 'doub',
				"setting for level for copied pasteboard audio",
				optional,
				singleItem, notEnumerated, Reserved13,
				"inside", 'Insd', 'bool',
				"if yes, paste inside selection only",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"clear",
			"Delete audio",
			'SndS', 'Clea',
			reply_none__,
			'obj ',
			"selection",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"silence",
			"Silence",
			'SndS', 'Sile',
			reply_none__,
			'obj ',
			"selection",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"crop",
			"Crop by deleting audio before and after the specified times.",
			'SndS', 'Crop',
			reply_none__,
			'obj ',
			"the item(s) to crop",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"start", 'CrSt', 'doub',
				"the start time for the crop",
				required,
				singleItem, notEnumerated, Reserved13,
				"end", 'CrEn', 'doub',
				"the end time for the crop",
				required,
				singleItem, notEnumerated, Reserved13
			},

			"split",
			"Split by markers and save to files.",
			'SndS', 'Splt',
			'file',
			"files created",
			replyRequired, listOfItems, notEnumerated, Reserved13,
			'obj ',
			"the document to split",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"into", 'Into', 'TEXT',
				"the folder into which to save, as a POSIX path (/Users/name/Desktop for example).",
				optional,
				singleItem, notEnumerated, Reserved13,
				"prefix", 'Prfx', 'bool',
				"if set, prefix file names with a number (01, 02, 03, etc.)",
				optional,
				singleItem, notEnumerated, Reserved13,
				"start", 'PrSt', 'long',
				"the number from which to start counting",
				optional,
				singleItem, notEnumerated, Reserved13,
				"format", 'FFmt', 'TEXT',
				"file format (for example: 'AIFF Audio', 'MP3 Audio', 'AAC (m4a)' or 'WAVE Audio'). See the 'Split by Markers' dialog for a full list. The strings 'MP3' and 'AAC' are also recognized.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"bit rate", 'BtRt', 'long',
				"target bit rate for MP3 and AAC formats (8000 to 320000)",
				optional,
				singleItem, notEnumerated, Reserved13,
				"sample size", 'SSiz', 'long',
				"sample size for AIFF, WAVE and other PCM formats",
				optional,
				singleItem, notEnumerated, Reserved13,
				"replacing", 'Over', 'bool',
				"if set to yes, replace any existing files with the same name",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"insert silence at",
			"Insert silence at selection.",
			'SndS', 'InSi',
			reply_none__,
			'obj ',
			"the selection",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"duration", 'Dura', 'doub',
				"the duration, in seconds, of the silence to be inserted",
				required,
				singleItem, notEnumerated, Reserved13,
				"replacing selection", 'Repl', 'bool',
				"if set, replace the selection with specified duration of silence, otherwise insert silence after selection. Default is yes.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"insert tone at",
			"Insert tone at selection.",
			'SndS', 'InTo',
			reply_none__,
			'obj ',
			"the selection",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"duration", 'Dura', 'doub',
				"the duration, in seconds, of the tone to be inserted.",
				required,
				singleItem, notEnumerated, Reserved13,
				"amplitude", 'Ampl', 'doub',
				"the amplitude, in decibels, of the tone to be inserted. This is typically a negative value. Defaults to 0 dB.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"frequency", 'Freq', 'doub',
				"the frequency, in hertz, of the tone to be inserted.",
				required,
				singleItem, notEnumerated, Reserved13,
				"wave shape", 'WaSh', 'WaSh',
				"the wave shape of the tone to be inserted. Defaults to sine wave.",
				optional,
				singleItem, enumerated, Reserved13,
				"replacing selection", 'Repl', 'bool',
				"if set, replace the selection, otherwise insert after selection. Default is yes.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"insert fm at",
			"Insert FM Synthesis at selection.",
			'SndS', 'InFM',
			reply_none__,
			'obj ',
			"the selection",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"duration", 'Dura', 'doub',
				"the duration, in seconds, of the tone to be inserted",
				required,
				singleItem, notEnumerated, Reserved13,
				"amplitude", 'Ampl', 'doub',
				"the amplitude, in decibels, of the tone to be inserted. This is typically a negative value. Defaults to 0 dB.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"carrier", 'Freq', 'doub',
				"the carrier frequency, in hertz, of the tone to be inserted.",
				required,
				singleItem, notEnumerated, Reserved13,
				"modulation", 'Modu', 'doub',
				"the modulation frequency, in hertz, of the tone to be inserted.",
				required,
				singleItem, notEnumerated, Reserved13,
				"deviation", 'Devi', 'doub',
				"the deviation frequency, in hertz, of the tone to be inserted.",
				required,
				singleItem, notEnumerated, Reserved13,
				"replacing selection", 'Repl', 'bool',
				"if set, replace the selection, otherwise insert after selection. Default is yes.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"amplify",
			"Apply the Amplify/Volume filter to the audio.",
			'SndS', 'Ampl',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"by", 'Gain', 'doub',
				"the gain, in decibels; amplification or volume change.",
				required,
				singleItem, notEnumerated, Reserved13
			},

			"fade",
			"Apply the Fade In/Out filter to the audio.",
			'SndS', 'Fade',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"start", 'FaSt', 'doub',
				"the start time for the fade. If not set, then fade the entire selection or document.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"end", 'FaEn', 'doub',
				"the end time for the fade. If not set, then fade the entire selection or document.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"direction", 'FaDi', 'FaDi',
				"if set, applies a linear fade in if coming and a linear fade out if going; the fade is coming in from silence or going out to silence.",
				optional,
				singleItem, enumerated, Reserved13,
				"data points", 'DtPt', 'doub',
				"a set of data points in the form of x-y coordinate pairs, such as {0.0, 1.0, 1.0, 1.0}. If set, this overrides the direction parameter.",
				optional,
				listOfItems, notEnumerated, Reserved13
			},

			"normalize",
			"Apply the Normalize filter to the audio.",
			'SndS', 'Norm',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'Peak', 'doub',
				"the level which to set the peak, in decibels.",
				required,
				singleItem, notEnumerated, Reserved13,
				"independently", 'Inde', 'bool',
				"if set, adjust the levels in each track separately from each other, otherwise determine a single amplification factor for all tracks and apply the same change to all tracks.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"RMS", 'RMS ', 'bool',
				"if set, measure levels using root-mean-square, which is the average power of the signal, otherwise use the peaks, which are the tallest parts of the waveform.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"compress dynamics of",
			"Apply the Dynamics Compressor filter to the audio.",
			'SndS', 'Comp',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"rms", 'TRms', 'bool',
				"If set to yes, use RMS to measure the signal. If set to no, use peaks to measure the signal.",
				required,
				singleItem, notEnumerated, Reserved13,
				"threshold", 'TLev', 'doub',
				"the level above which to compress the waveform, in decibels.",
				required,
				singleItem, notEnumerated, Reserved13,
				"ratio", 'Rati', 'doub',
				"the compression ratio.",
				required,
				singleItem, notEnumerated, Reserved13,
				"attack", 'Atta', 'doub',
				"how fast the compressor reacts to the level going above the threshold, in seconds.",
				required,
				singleItem, notEnumerated, Reserved13,
				"release", 'Rele', 'doub',
				"how fast the compressor reacts to the level going above the threshold, in seconds.",
				required,
				singleItem, notEnumerated, Reserved13,
				"post", 'Post', 'doub',
				"the post gain, in decibels. If omitted, post gain is automatic.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"expand dynamics of",
			"Apply the Dynamics Expander filter to the audio.",
			'SndS', 'Expa',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"rms", 'TRms', 'bool',
				"If set to yes, use RMS to measure the signal. If set to no, use peaks to measure the signal.",
				required,
				singleItem, notEnumerated, Reserved13,
				"threshold", 'TLev', 'doub',
				"the level above which to compress the waveform, in decibels.",
				required,
				singleItem, notEnumerated, Reserved13,
				"ratio", 'Rati', 'doub',
				"the compression ratio.",
				required,
				singleItem, notEnumerated, Reserved13,
				"attack", 'Atta', 'doub',
				"how fast the compressor reacts to the level going above the threshold, in seconds.",
				required,
				singleItem, notEnumerated, Reserved13,
				"release", 'Rele', 'doub',
				"how fast the compressor reacts to the level going above the threshold, in seconds.",
				required,
				singleItem, notEnumerated, Reserved13
			},

			"noise gate",
			"Apply the Dynamics Noise Gate Expander filter to the audio.",
			'SndS', 'NzGt',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"rms", 'TRms', 'bool',
				"If set to yes, use RMS to measure the signal. If set to no, use peaks to measure the signal.",
				required,
				singleItem, notEnumerated, Reserved13,
				"threshold", 'TLev', 'doub',
				"the level above which to compress the waveform, in decibels.",
				required,
				singleItem, notEnumerated, Reserved13,
				"attack", 'Atta', 'doub',
				"how fast the compressor reacts to the level going above the threshold, in seconds.",
				required,
				singleItem, notEnumerated, Reserved13,
				"release", 'Rele', 'doub',
				"how fast the compressor reacts to the level going above the threshold, in seconds.",
				required,
				singleItem, notEnumerated, Reserved13
			},

			"add noise to",
			"Apply the Add Noise filter to the audio.",
			'SndS', 'AdNo',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"amplitude", 'Ampl', 'doub',
				"the noise amplitude, in decibels, of the noise to be inserted. This is typically a negative value.",
				required,
				singleItem, notEnumerated, Reserved13
			},

			"add more cowbell to",
			"More Cowbell. Really explore the studio space this time.",
			'SndS', 'AdCB',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"amplitude", 'Ampl', 'doub',
				"how much cowbell?",
				required,
				singleItem, notEnumerated, Reserved13
			},

			"dc offset",
			"Apply the DC Offset filter to the audio.",
			'SndS', 'DCOf',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"by", 'By  ', 'doub',
				"the percent to offset, typically from -100 to 100. If omitted, this command will remove any DC offset.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"interpolate",
			"Apply the Interpolate filter to the audio; replaces audio with a straight line between the first and last samples.",
			'SndS', 'Iplt',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"invert",
			"Apply the Invert Signal Polarity filter to the audio; flips audio vertically.",
			'SndS', 'Inve',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"swap channels of",
			"Apply the Swap Left and Right Channels filter to the audio; swaps audio data between even and odd numbered tracks.",
			'SndS', 'SwCh',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"reverse",
			"Apply the Backwards/Reverse Audio filter to the audio; makes audio sound like it is played backwards.",
			'SndS', 'SwCh',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"add chorus to",
			"Apply the Chorus filter to the audio.",
			'SndS', 'Chor',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"dry", 'Dry ', 'doub',
				"the dry mix level, in decibels. Defaults to 0 dB.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"wet", 'Wet ', 'doub',
				"the wet mix level, in decibels. Defaults to 0 dB.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"speed", 'Sped', 'doub',
				"the speed at which the chorus cycles, in seconds. Defaults to 2 seconds.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"delay", 'Dlay', 'doub',
				"the minimum delay, in milliseconds. Defaults to 10 milliseconds.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"depth", 'Dpth', 'doub',
				"the sweep depth, in milliseconds. Defaults to 15 milliseconds.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"add delay to",
			"Apply the Delay and Echo filter to the audio.",
			'SndS', 'Dlay',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"dry", 'Dry ', 'doub',
				"the dry mix level, in decibels. Defaults to 0 dB.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"wet", 'Wet ', 'doub',
				"the wet mix level, in decibels. Defaults to 0 dB.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"delay", 'Dlay', 'doub',
				"the delay, in seconds. Defaults to 0.1 seconds.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"feedback", 'Fdbk', 'bool',
				"if set to yes, feed the delayed audio back into the feedback loop. Defaults to no.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"flange",
			"Apply the Flanger filter to the audio.",
			'SndS', 'Flan',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"dry", 'Dry ', 'doub',
				"the dry mix level, in decibels. Defaults to 0 dB.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"wet", 'Wet ', 'doub',
				"the wet mix level, in decibels. Defaults to 0 dB.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"speed", 'Sped', 'doub',
				"the speed at which the flanger cycles, in seconds. Defaults to 2 seconds.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"delay", 'Dlay', 'doub',
				"the minimum delay, in milliseconds. Defaults to 10 milliseconds.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"depth", 'Dpth', 'doub',
				"the sweep depth, in milliseconds. Defaults to 15 milliseconds.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"change pitch of",
			"Apply the Pitch and Tempo filter to the audio.",
			'SndS', 'Ptch',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"by", 'By  ', 'doub',
				"the factor to multiply the pitch by, in percent. Defaults to 100%.",
				required,
				singleItem, notEnumerated, Reserved13
			},

			"add reverb to",
			"Apply the Reverb filter to the audio.",
			'SndS', 'Rvrb',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"room size", 'RmSz', 'doub',
				"the approximate width and length of the room to simulate, in meters. Defaults to 10 meters.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"decay", 'Dcay', 'doub',
				"the decay, in seconds. Defaults to 2 seconds.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"color", 'Colr', 'doub',
				"the cut-off for the low-pass filter, in hertz. Defaults to 12,800 Hz.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"wet", 'Wet ', 'doub',
				"the wet mix level, in decibels. Defaults to -20 dB.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"equalize",
			"Apply the Graphic Equalizer filter to the audio.",
			'SndS', 'GrEQ',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"data points", 'DtPt', 'doub',
				"the cut-off frequency, in hertz.",
				required,
				listOfItems, notEnumerated, Reserved13
			},

			"high pass",
			"Apply the High Pass filter to the audio.",
			'SndS', 'HiPa',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"frequency", 'Freq', 'doub',
				"the cut-off frequency, in hertz.",
				required,
				singleItem, notEnumerated, Reserved13,
				"steepness", 'Stee', 'long',
				"the steepness or window width, in number of samples. A higher number results in a steeper drop-off. Defaults to 63 samples.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"low pass",
			"Apply the Low Pass filter to the audio.",
			'SndS', 'LoPa',
			reply_none__,
			'obj ',
			"the item(s) to filter",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"frequency", 'Freq', 'doub',
				"the cut-off frequency, in hertz.",
				required,
				singleItem, notEnumerated, Reserved13,
				"steepness", 'Stee', 'long',
				"the steepness or window width, in number of samples. A higher number results in a steeper drop-off. Defaults to 63 samples.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"expand tilde",
			"Expand tilde in POSIX path to full absolute path. (Example: expand tilde document from \"~/Desktop/\".) Granted, the syntax of this command isn't elegant, but I'm working with the default Cocoa AppleScript implementation's limitations.",
			'SndS', 'CvPa',
			'TEXT',
			"the absolute path",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'obj ',
			"document to use for conversion",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"from", 'From', 'TEXT',
				"the tilde path.",
				required,
				singleItem, notEnumerated, Reserved13
			}
		},
		{
			/* Classes */

			"marker", 'Mark',
			"An audio marker. This class represents an individual marker cue point in the document.",
			{
				"ident", 'Iden', 'long',
				"the numeric identifier (ID).",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"position", 'Posi', 'long',
				"the position of the marker in the file, as a sample offset.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"name", 'pnam', 'TEXT',
				"the marker's name.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"markers", 'Mark', plural__,

			"track", 'Trak',
			"An audio track. This class represents an individual audio track in the document.",
			{
				"volume", 'Vol ', 'doub',
				"the track volume in decibels.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"pan", 'Pann', 'doub',
				"the track pan, where -1 is hard left, 0 is center, and 1 is hard right.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"tracks", 'Trak', plural__,

			"sound selection", 'SSel',
			"A selection. For macro-type scripting, almost all the commands use a sound selection as the direct parameter. Get the selection from the application or window.",
			{
				"start time", 'Strt', 'doub',
				"the beginning of the selection, in seconds.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"stop time", 'Stop', 'doub',
				"the end of the selection, in seconds.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"first track", 'Trk1', 'long',
				"the index of the first track of the selection.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"track count", 'NTrk', 'long',
				"the number of tracks in the selection.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"sound selections", 'SSel', plural__
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
			'TkCf',
			{
				"mono", 'Mono', "Monophonic audio.",
				"stereo", 'Ster', "Stereophonic audio."
			},

			'WaSh',
			{
				"sine", 'Sine', "a pure sine wave.",
				"square", 'Squa', "a square wave.",
				"triangle", 'Tria', "a triangular wave."
			},

			'FaDi',
			{
				"coming", 'In  ', "Fade In",
				"going", 'Out ', "Fade Out"
			}
		}
	}
};
